/*
 * radialBackgroundSubtraction_wrapper.h
 *
 *  Created on: 04.08.2016
 *      Author: gevorkov
 */

#ifndef RADIALBACKGROUNDSUBTRACTION_WRAPPER_H_
#define RADIALBACKGROUNDSUBTRACTION_WRAPPER_H_

#include "fastDiffractionImageProcessing/radialBackgroundSubtraction.h"
#include "fastDiffractionImageProcessing/adaptions/onda/pythonWrapperTypes.h"
#include "fastDiffractionImageProcessing/detectorRawFormat.h"
#include <ctype.h>

typedef struct {
    radialBackgroundSubtraction_precomputedConstants_t* precomputedConstants;
    detectorRawFormat_t* detectorRawFormat;
    detectorPositions_t* detectorPositions;
} radialBackgroundSubtraction_constantArguments_t;

typedef struct {
    uint32_t minValuesPerBin;
    uint32_t minBinWidth;

    uint32_t maxConsideredValuesPerBin;    //0 for infinite

    //Point (x,y) in the way the detector is positioned in the rawImage (top left detector is (0,0), it's right neighbor is (1,0) )
    uint8_t* detectorsToConsiderSubscripts_x;
    uint8_t* detectorsToConsiderSubscripts_y;
    uint16_t detectorsToConsiderCount;

    //must be a subset of detektorsToConsiderIndices
    uint8_t* detectorsToCorrectSubscripts_x;
    uint8_t* detectorsToCorrectSubscripts_y;
    uint16_t detectorsToCorrectCount;

    float rank; //between 0 and 1
    float rankSmoothing; //between 0 and 1
} radialBackgroundSubtraction_accuracyConstants_pythonWrapper_t;

radialBackgroundSubtraction_constantArguments_t precomputeRadialBackgroundSubtractionConstantArguments(const uint8_t* mask, const float* detectorGeometryRadiusMatrix,
        const detectorRawFormat_t& detectorRawFormat, const radialBackgroundSubtraction_accuracyConstants_pythonWrapper_t& accuracyConstants_pythonWrapper,
        detectorGeometryMatrix_pythonWrapper_t detectorGeometryMatrix_pythonWrapper);

void applyRadialBackgroundSubtraction(float* data, radialBackgroundSubtraction_constantArguments_t radialRankFilter_constantArguments);

void freePrecomputeRadialBackgroundSubtractionConstants(radialBackgroundSubtraction_constantArguments_t radialRankFilter_constantArguments);

#endif /* RADIALBACKGROUNDSUBTRACTION_WRAPPER_H_ */
