/*
 * ringFinder_wrapper.h
 *
 *  Created on: 17.05.2018
 *      Author: gevorkov
 */

#ifndef INCLUDE_ADAPTIONS_ONDA_RINGFINDER_WRAPPER_H_
#define INCLUDE_ADAPTIONS_ONDA_RINGFINDER_WRAPPER_H_

#include "fastDiffractionImageProcessing/adaptions/onda/pythonWrapperTypes.h"
#include "fastDiffractionImageProcessing/ringFinder.h"

typedef struct {
    ringFinder_precomputedConstants_t* precomputedConstants;
} ringFinder_constantArguments_t;


ringFinder_constantArguments_t precomputeRingFinderConstantArguments(const float* detectorGeometryRadiusMatrix_linear,
        const ringFinder_accuracyConstants_t& accuracyConstants, const detectorRawFormat_t& detectorRawFormat);

void applyRingFinder(float* data, ringFinder_constantArguments_t ringFinder_constantArguments);

void freePrecomputedRingFinderConstantArguments(ringFinder_constantArguments_t radialRankFilter_constantArguments);


#endif /* INCLUDE_ADAPTIONS_ONDA_RINGFINDER_WRAPPER_H_ */
