/*
 * testFileHandling.h
 *
 *  Created on: 10.12.2015
 *      Author: Yaro
 */

#ifndef TESTFILEHANDLING_H_
#define TESTFILEHANDLING_H_

#include <stdint.h>
#include <cmath>
#include "fastDiffractionImageProcessing/detectorGeometry.h"

extern const unsigned CSPAD_ASIC_NX;  // ASIC nx = extent of one ASIC in x
extern const unsigned CSPAD_ASIC_NY;  // ASIC ny = extent of one ASIC in y
extern const unsigned CSPAD_nASICS_X;   // 8 ASICs across in raw data stream
extern const unsigned CSPAD_nASICS_Y;   // 8 ASICs down in raw data stresm

void importTestImage(const char imageFilename[], const char maskFilename[], const char detectorGeometryMatrixCommonFilename[],
        const char detectorRawSizeFilename[], float** data, uint8_t** mask,
        Eigen::Vector2f** detectorGeometryMatrix, float** detectorGeometryRadiusMatrix, detectorRawFormat_t& detectorRawFormat);
void exportTestImage(const char imageFilename[], const char maskFilename[], float* data, uint8_t* mask,
        const detectorRawFormat_t& detectorRawFormat);
void allocateTestImageCopy(float** dataCopy, const detectorRawFormat_t& detectorRawFormat);
void deleteTestImageCopy(float* dataCopy);
void deleteTestImage(float* data, uint8_t* mask, Eigen::Vector2f* detectorGeometryMatrix, float* detectorGeometryRadiusMatrix);

#endif /* TESTFILEHANDLING_H_ */
