/*
 * ringFinder_wrapper.cpp
 *
 *  Created on: 17.05.2018
 *      Author: gevorkov
 */

#include <fastDiffractionImageProcessing/adaptions/onda/ringFinder_wrapper.h>

ringFinder_constantArguments_t precomputeRingFinderConstantArguments(const float* detectorGeometryRadiusMatrix_linear,
        const ringFinder_accuracyConstants_t& accuracyConstants, const detectorRawFormat_t& detectorRawFormat)
{

    ringFinder_precomputedConstants_t* precomputedConstants_heap = new ringFinder_precomputedConstants_t;

    precomputeRingFinderConstants(*precomputedConstants_heap, detectorGeometryRadiusMatrix_linear,
            accuracyConstants, detectorRawFormat);

    ringFinder_constantArguments_t ringFinder_constantArguments;
    ringFinder_constantArguments.precomputedConstants = precomputedConstants_heap;
    return ringFinder_constantArguments;
}

void applyRingFinder(float* data, ringFinder_constantArguments_t ringFinder_constantArguments)
{
    ringFinder(data, *ringFinder_constantArguments.precomputedConstants);
}

void freePrecomputedRingFinderConstantArguments(ringFinder_constantArguments_t radialRankFilter_constantArguments)
{
    delete radialRankFilter_constantArguments.precomputedConstants;
}
